<?php

use App\Base\Base;

use App\Models\order\mysql\PayOrderItem;
use App\Services\pay\PayService;
use App\Services\refund\RefundService;
use App\Models\order\mysql\CallbackLog;
use Helpers\DingTalk;

class TccController extends Base
{
    /**
     * 创建支付订单，返回前端ping++的支付信息
     */
    public function tryAction()
    {

        if(!empty($this->params['sleep'])) {
            sleep($this->params['sleep']);
        }

        if(!empty($this->params['throw'])) {
            throw new \Exception('test for Exception.', '3001');
        }

        if(!empty($this->params['lock'])) {

            //todo make a lock for mysql
        }

        $this->success(['result'=>[]]);
    }

    public function confirmAction() {

        if(!empty($this->params['sleep'])) {
            sleep($this->params['sleep']);
        }

        if(!empty($this->params['throw'])) {
            throw new \Exception('test for Exception.', '3001');
        }

        if(!empty($this->params['lock'])) {

            //todo make a lock for mysql
        }

        $this->success(['result'=>[]]);
    }

    public function cancelAction() {

        if(!empty($this->params['sleep'])) {
            sleep($this->params['sleep']);
        }

        if(!empty($this->params['throw'])) {
            throw new \Exception('test for Exception.', '3001');
        }

        if(!empty($this->params['lock'])) {

            //todo make a lock for mysql
        }

        $this->success(['result'=>[]]);

    }

    public function traceAction() {
        \Helpers\Tracer::info('traceId', '');
    }


    public function pdoAction() {

        $dsn = 'mysql:dbname=testdb;host=127.0.0.1';
        $user = 'dbuser';
        $password = 'dbpass';


        $user = config('mysql', 'pay.username');
        $password = config('mysql', 'pay.password');
        $host = config('mysql', 'pay.write.host');
        $db = config('mysql', 'pay.database_name');

        $dsn = 'mysql:dbname=' . $db . ';host=' . $host;

        $dbh = new PDO($dsn, $user, $password);

        sleep(15);

        $sth = $dbh->prepare('SELECT * FROM pay_order WHERE user_id = ? limit 1');
        var_dump($sth, '----');

        $sth->execute([510226436112]);
        $one = $sth->fetchAll();
        $sth->execute([510230120298]);
        $two = $sth->fetchAll();

        $this->success(['one'=>$one, 'two'=>$two]);

    }
}
